-- Ce module est appele "full_add". C'est une description comportementale, niveau
--equations logiques, d'un additionneur 1 bit.

-- Il faut d'abord dfinir les bibliothque utilises. Par dfaut VHDL
-- utilise les bibliothques" std" et "textio" et le rsultat de compilation
-- est dans "work" . Il est conseill d'utiliser la bibliothque normalise IEEE
-- avec ses paquetages std_logic_1164 et numeric_std car elles contiennet des types et des fonctions trs utiles */

library IEEE;
use IEEE.std_logic_1164. all;
use IEEE.numeric_std.all;

-- Cette ligne definit un "composant", autrement dit un bloc, un sous-ensemble, un module.
-- On donne la liste de ses entrees et sorties (appeles "ports") entre parentheses, 
-- en terminant par un point-virgule.

--  L'ordre des entrees-sortie importe peu ici, et les habitude changent selon les endroits. 
-- cette convention-ci est gnralement employe:
--   - l'horloge, s'il y en a une, en premier
--   - le reset, s'il y en a un, en deuxieme
--   - puis les entrees
--  - puis les sorties
--   - puis les entrees-sorties (bidirectionnelles).

-- Une bonne habitude est mettre chaque entit dans un fichier, et appeler le fichier du mme
-- nom que l'entit.

entity full_add is

-- Puis on donne la direction des ports
--        - "in"  pour une entree
--        - "out" pour une sortie
--        - "inout"  pour un port bidirectionnel
--   et le type IEEE.
--        - std_logic pour 1 bit
--        - unsigned pour un vecteur non sign de std_logic
--        - signed pour un vecteur sign de std_logic

  port(
    a    : in  std_logic;
    b : in std_logic;
    cin  : in  std_logic;
    s    : out std_logic;
    cout : out std_logic
    );
end entity;


--   On verra plus loin ce que ces type signifient. 

-- Enfin, on dcrit le contenu du bloc, c'est  dire l'architecture. Une
-- entit peut avoir plusieurs architectures donc il est ncessaire de
-- spcifier un nom d'architecture

architecture arc of full_add is

begin  -- arc

-- On en fait ici une description fonctionnelle, c'est-a-dire qu'on assigne  chaque
-- equipotentielle le resultat d'une equation mathematique ou booleenne.

  s    <= a xor b xor cin;
  cout <= (a and b) or (a and cin) or (b and cin);

end arc;
